#!/usr/bin/wish
#============================
set title  "NakenChat Client            ::OpenNaken Windows Version 0.50 Beta::"
proc init_colors { } {
.topwindow.chat config -background black -foreground lightblue
.topwindow.chat tag configure red -foreground purple

}
#============================
proc init_menu { } {
  frame .menu69 -relief raised -bd 2
  pack .menu69 -side bottom -padx 1 -pady 1 -fill x
  menubutton .menu69.a -text "The server you log on to is sometimes off a modem line, on port 6666.                                                   OpenNaken is brought to you by Daemon Inc." -menu .menu69.a.menu69
  set aa [menu .menu69.a.menu69 -tearoff 0]
  pack .menu69.a -side left -fill y
  frame .menu -relief raised -bd 2 
  pack .menu -side top -padx 1 -pady 1 -fill x
  menubutton .menu.f -text "File" -underline 0 -menu .menu.f.menu
  set a [menu .menu.f.menu -tearoff 0]
  $a add command -label "Save Screen" -underline 0 -command { menuSaveBuffer }
  $a add separator
  $a add command -label "Commands" -underline 1 -command {wm deiconify .commands}
  $a add separator
  $a add command -label Exit -underline 1 -command { exit }
  menubutton .menu.a -text "Chat Colors" -underline 0 -menu .menu.a.menu9
  set b [menu .menu.a.menu9 -tearoff 0]
  $b add command -label "Default Notice Color" -command {init_notice1} 
  $b add command -label "Default Chat Color" -command {init_default1} 
  $b add separator
  $b add cascade -label "Notice Color..." -menu $b.55
  set 55 [menu $b.55 -tearoff 0]
  $55 add command -label "Red" -command {init_colorsa} 
  $55 add command -label "White" -command {init_colorsb}
  $55 add command -label "Blue" -command {init_colorsc}
  $55 add command -label "LightBlue" -command {init_colorsd}
  $55 add command -label "Green" -command {init_colorse}
  $55 add command -label "Yellow" -command {init_colorsf}
  $55 add command -label "Black" -command {init_colorsg}
  $55 add command -label "Gray" -command {init_colorsh}
  $55 add command -label "LightGray" -command {init_colorsi}
  $b add separator
  $b add cascade -label "Background Color..." -menu $b.1
  set 1 [menu $b.1 -tearoff 0]
  $1 add command -label "Red" -command {init_colors1} 
  $1 add command -label "White" -command {init_colors2}
  $1 add cascade -label "Blue" -menu $b.3
  set 3 [menu $b.3 -tearoff 0]
  $3 add command -label "Blue" -command {init_colors3}
  $3 add command -label "LightBlue" -command {init_colors100}
  $1 add command -label "Green" -command {init_colors4}
  $1 add command -label "Yellow" -command {init_colors5}
  $1 add command -label "Black" -command {init_colors6}
  $1 add command -label "Gray" -command {init_colors7}
  $1 add command -label "LightGray" -command {init_colors8}
  $b add separator
  $b add cascade -label "Foreground Color..." -menu $b.2
  set 2 [menu $b.2 -tearoff 0]
  $2 add command -label "Red" -command {init_colors11}
  $2 add command -label "White" -command {init_colors21}
  $2 add cascade -label "Blue" -menu $b.4
  set 4 [menu $b.4 -tearoff 0]
  $4 add command -label "Blue" -command {init_colors3}
  $4 add command -label "LightBlue" -command {init_colors100}
  $2 add command -label "Green" -command {init_colors41}
  $2 add command -label "Yellow" -command {init_colors51}
  $2 add command -label "Black" -command {init_colors61}
  $2 add command -label "Gray" -command {init_colors71}
  $2 add command -label "LightGray" -command {init_colors81}
  menubutton .menu.d -text "Font" -underline 0 -menu .menu.d.menu1
  set d [menu .menu.d.menu1 -tearoff 0]
  $d add cascade -label "Font size 12" -menu $d.12
  set 12 [menu $d.12 -tearoff 0]
  $12 add command -label "Normal" -command {init_font0}
  $12 add command -label "Bold" -command {init_font00}
  $12 add command -label "Italic" -command {init_font000}
  $d add separator
  $d add cascade -label "Font size 13" -menu $d.13
  set 13 [menu $d.13 -tearoff 0]
  $13 add command -label "Normal" -command {init_font1}
  $13 add command -label "Bold" -command {init_font11}
  $13 add command -label "Italic" -command {init_font111}
  $d add separator
  $d add cascade -label "Font size 14" -menu $d.14
  set 14 [menu $d.14 -tearoff 0]
  $14 add command -label "Normal" -command {init_font4}
  $14 add command -label "Bold" -command {init_font44}
  $14 add command -label "Italic" -command {init_font444}
  $d add separator
  $d add cascade -label "Font size 15" -menu $d.15
  set 15 [menu $d.15 -tearoff 0]
  $15 add command -label "Normal" -command {init_font2}
  $15 add command -label "Bold" -command {init_font22}
  $15 add command -label "Italic" -command {init_font222}
  menubutton .menu.c -text "Window" -underline 0 -menu .menu.c.menu1
  set c [menu .menu.c.menu1 -tearoff 0]
  $c add command -label "Help" -underline 1 -command {wm deiconify .help}
  $c add command -label "About..." -underline 2 -command {wm deiconify .about} 
  pack .menu.f .menu.a .menu.d .menu.c -side left
#============================
proc init_notice1 { } {
.topwindow.chat tag configure red -foreground purple
}
proc init_default1 { } {
.topwindow.chat config -background black -foreground lightblue
}
#============================
proc init_font4 { } {
.topwindow.chat config -font -*-verdana-medium-r-normal--*-140-*
}
proc init_font44 { } {
.topwindow.chat config -font -*-verdana-bold-r-normal--*-140-*
}
proc init_font444 { } {
.topwindow.chat config -font -*-verdana-italic-o-normal--*-140-*
}
#============================
proc init_font0 { } {
.topwindow.chat config -font -*-verdana-medium-r-normal--*-120-*
}
proc init_font00 { } {
.topwindow.chat config -font -*-verdana-bold-r-normal--*-120-*
}
proc init_font000 { } {
.topwindow.chat config -font -*-verdana-italic-o-normal--*-120-*
}
#============================
proc init_font2 { } {
.topwindow.chat config -font -*-verdana-medium-r-normal--*-160-*
}
proc init_font22 { } {
.topwindow.chat config -font -*-verdana-bold-r-normal--*-160-*
}
proc init_font222 { } {
.topwindow.chat config -font -*-verdana-italic-o-normal--*-160-*
}
#============================
proc init_font1 { } {
.topwindow.chat config -font -*-verdana-medium-r-normal--*-130-*
}
proc init_font11 { } {
.topwindow.chat config -font -*-verdana-bold-r-normal--*-130-*
}
proc init_font111 { } {
.topwindow.chat config -font -*-verdana-italic-o-normal--*-130-*
}
#============================
proc init_colorsa { } {
.topwindow.chat tag configure red -foreground red
}
proc init_colorsb { } {
.topwindow.chat tag configure red -foreground white
}
proc init_colorsc { } {
.topwindow.chat tag configure red -foreground blue
}
proc init_colorse { } {
.topwindow.chat tag configure red -foreground green
}
proc init_colorsd { } {
.topwindow.chat tag configure red -foreground lightblue
}
proc init_colorsf { } {
.topwindow.chat tag configure red -foreground yellow
}
proc init_colorsg { } {
.topwindow.chat tag configure red -foreground black
}
proc init_colorsh { } {
.topwindow.chat tag configure red -foreground gray
}
proc init_colorsi { } {
.topwindow.chat tag configure red -foreground lightgray
}
#============================
proc init_colors1 { } {
.topwindow.chat config -background red
}
proc init_colors2 { } {
.topwindow.chat config -background white
}
proc init_colors3 { } {
.topwindow.chat config -background blue
}
proc init_colors4 { } {
.topwindow.chat config -background green
}
proc init_colors100 { } {
.topwindow.chat config -background lightblue
}
proc init_colors5 { } {
.topwindow.chat config -background yellow
}
proc init_colors6 { } {
.topwindow.chat config -background black
}
proc init_colors7 { } {
.topwindow.chat config -background gray
}
proc init_colors8 { } {
.topwindow.chat config -background lightgray
}
#============================
proc init_colors101 { } {
.topwindow.chat config -foreground lightblue
}
proc init_colors11 { } {
.topwindow.chat config -foreground red
}
proc init_colors21 { } {
.topwindow.chat config -foreground white
}
proc init_colors31 { } {
.topwindow.chat config -foreground blue
}
proc init_colors41 { } {
.topwindow.chat config -foreground green
}
proc init_colors51 { } {
.topwindow.chat config -foreground yellow
}
proc init_colors61 { } {
.topwindow.chat config -foreground black
}
proc init_colors71 { } {
.topwindow.chat config -foreground gray
}
proc init_colors81 { } {
.topwindow.chat config -foreground lightgray
}
#============================
proc menuSaveBuffer { } {

  set file [ tk_getSaveFile -initialdir "~/" -initialfile "OpenNakenScreen.txt" -title "Save As..." ]
  if [ file exists $file ] {
    file delete -force $file
  }
  
  if [ catch { open $file w 0600 } fileId ] {
    puts stderr "Cannot open $file: $fileId"
  } else {
    puts $fileId [ .topwindow.chat get 0.0 end ]
    close $fileId
  }

}
#============================
}

proc init { } {
  global back
  global username
  global userpass
  global conn
  global title
  bind . <Alt-x> exit
  wm title . $title
#===========================
toplevel .about 
wm title .about "OpenNaken: About"
.about config -background black 
button .about.ok -text "Close" -command {wm withdraw .about} -background black -foreground lightblue
pack .about.ok -side bottom -pady 8
label .about.info -text "http://OpenNaken.tsx.org
to get a copy of the server goto
ftp://naken.i1.net/pub/nakenchat/" -background black -foreground lightblue
pack .about.info -side bottom -fill x
catch {.about.info configure -font -*-helvetica-italic-o-normal--*-150-*}
label .about.explain -text "OpenNaken... Naken Chat Client v0.50" -background black -foreground lightblue
pack .about.explain -fill x -padx 8 -pady 8
catch {.about.explain configure -font -*-helvetica-bold-o-normal--*-180-*}
label .about.authors -text "By: Derrick Rose & Devin Smith" -background black -foreground lightblue
pack .about.authors -fill x -pady 8
catch {.about.authors configure -font -*-helvetica-medium-r-normal--*-160-*}
label .about.text -text "OpenNaken is freeware, it has been edited from another 
tcl program, called Battlechat. Get Battlechat at www.freshmeat.net" -background black -foreground lightblue
pack .about.text -fill x -pady 8
catch {.about.text configure -font -*-helvetica-medium-r-normal--*-160-*}
focus .about.ok
wm withdraw .about
#=============================
toplevel .help
wm title .help "OpenNaken: Help"
.help config -background black 
button .help.ok -text "Close" -command {wm withdraw .help} -background black -foreground lightblue
pack .help.ok -side bottom -pady 8
label .help.logo -text "OpenNaken Help Menu:" -background black -foreground lightblue
pack .help.logo -fill  x -padx 8 -pady 8
catch {.help.logo configure -font -*-helvetica-bold-r-normal--*-180-*}
label .help.explain -text "The first thing to do is place a <name> or <username> 
you wish to be in <NAME/USERNAME> (Ex:OpenaNaken). Next, you must add a Naken Server 
Ip in the next feld <SERVER>, where you wish to go. (Ex:OpenNaken.com)
After you have feld out both <NAME> and <SERVER> you well need to add a port number 
in the feld <PORT #>. Defualt port is set to 6666.

Ex: OpenNaken OpenNaken.com 6666

(Hint):
If you Just put your name in the <NAME/USERNAME> feild, then hit enter, you will automatically 
be brought to naken.i1.net port 6666" -background black -foreground lightblue
pack .help.explain -fill x -padx 8 -pady 8
catch {.help.explain configure -font -*-helvetica-bold-r-normal--*-160-*}
focus .help.ok
wm withdraw .help
#=============================
toplevel .commands
wm title .commands "OpenNaken: COMMANDS"
.commands config -background black 
button .commands.ok -text "Close" -command {wm withdraw .commands} -background black -foreground lightblue
pack .commands.ok -side bottom -pady 8
label .commands.explain -text "OpenNaken Commands Menu:" -background black -foreground lightblue
pack .commands.explain -fill x -padx 8 -pady 8
catch {.commands.explain configure -font -*-helvetica-bold-r-normal--*-180-*}
label .commands.text -text "Commands:
This Client connects to Naken servers - On Port 6666
====================================================
.w = list users 
.hu = toggle whether yell hushing is on or off
.n <name> = change name 
.c = move to a private channel named
.e = turn on private echos 
.y = cross channel yelling
.hu = toggle whether yell hushing is on or off 
.w = a long list of who's online with location and flags
.f = short list of who's online 
.a = list of all channels and who owns them
.k = kick out anyone out of that channel
.l = lock a channel 
.p <number> = sends a private message 
.o = channel owner can give ownership to someone else
.t = what time is it on the server computer?
.u = how long has this server
.v = the server version number
.s = channel owner can squelch users in the channel.
:  = this is an emote ex: ::) = :)
.b and .hi = these are beeps and highlights for private message. 
.help = help
" -background black -foreground lightblue
pack .commands.text -fill x -pady 8
catch {.commands.text configure -font -*-helvetica-medium-r-normal--*-160-*}
focus .commands.ok
wm withdraw .commands
#=========================
  init_menu
  frame .topwindow -relief flat -bd 2
  text .topwindow.chat -width 90 -height 25 -relief raised 
  .topwindow.chat config -yscrollcommand ".topwindow.chatsb set"
  bind .topwindow.chat <Button-1> { focus .topwindow.chat }
  bind .topwindow.chat <ButtonPress-1> { puts "click %x %y" }
  bind .topwindow.chat <B1-Motion> { puts "drag %x %y" }
  bind .topwindow.chat <ButtonRelease-1> { puts "drop %x %y" }
  catch {.topwindow.chat configure -font -*-verdana-medium-r-normal--*-130-*}
  scrollbar .topwindow.chatsb -command ".topwindow.chat yview"
  init_colors
  pack .topwindow.chat .topwindow.chatsb -side left -fill y
  pack .topwindow -side top -fill y
#===========================  
  frame .frame -relief raised -bd 2 -bg $back
  label .frame.label -text "Name (Username): " -relief flat -padx 8
  entry .frame.name -width 20 -textvariable username -bg $back
  bind .frame.name <KeyPress-Return> { pass_ok }
  label .frame.label2 -text "Connecting Server: " -relief flat -padx 8
  entry .frame.pass -width 20 -textvariable userpass -bg $back
  bind .frame.pass <KeyPress-Return> { pass_ok }
  label .frame.label3 -text "Port:" -relief flat -padx 8
  entry .frame.port -width 10 -textvariable userport -bg $back
  bind .frame.port <KeyPress-Return> { pass_ok }
  button .frame.submit -text "OK" -command { pass_ok } -padx 8 -bg $back
  bindtags .frame.submit { Button all .frame.submit . }
  bindtags .frame.name { Entry all .frame.name . }
  bind .frame.submit <Return> { pass_ok }
  bind .frame.submit <Tab> { focus .frame.name }
  bind .frame.submit <KeyPress-Return> { focus .frame.submit }
  bind .frame.name <Shift-Tab> { focus .frame.submit }
  pack .frame.label .frame.name .frame.label2 .frame.pass .frame.label3 .frame.port .frame.submit -side left -fill y
  pack .frame -fill x
  bindtags .topwindow.chat { Text .topwindow.chat . all }
  bind .topwindow.chat <Button-1> { focus .frame.name }
  focus .frame.name

}
#==========================
proc pass_ok {} {

  global back
  global username
  global userpass
  global userport
  global conn
  global textcomm
#====SET USERPASS TO WHAT EVER YOU WANT, EX: 127.0.0.1, DEFUALT IS NAKEN.I1.NET====
#
#
if { $userpass == "" } {
    set userpass "naken.i1.net"
   }
#====SET USERPORT TO WHAT EVER YOU WANT, EX: 23, DEFUALT IS 6666====
#
#
if { $userport == "" } {
    set userport "6666"
   }


   set conn [socket $userpass $userport]       
#  set conn [socket naken.i1.net 6666] 
  puts $conn ".n $username"; flush $conn
  
  gets $conn; gets $conn; gets $conn; gets $conn; gets $conn; gets $conn
  puts $conn ": Connected to a Naken Server, Using | OpenNaken Windows Version 0.50 |"; flush $conn
  puts $conn ".w"; flush $conn

set reply [gets $conn]
  gets $conn; set reply [gets $conn]
  destroy .frame
  frame .frame -relief flat -bd 2 -bg $back
  .frame config -cursor top_left_arrow
#==========================
  entry .frame.entry -width 105 -textvariable textcomm -bg $back -background gray -foreground black
  bind .frame.entry <Return> { updatechat $textcomm ; set textcomm "" }
  bind . <Next> { .topwindow.chat yview scroll 1 pages }
  bind . <Prior> { .topwindow.chat yview scroll -1 pages }
  pack .frame.entry -side left -fill both -ipadx 8
  pack .frame -fill x
  fileevent $conn readable do_loop
  bind .topwindow.chat <Button-1> { focus .frame.entry }
  focus .frame.entry

}
#==========================
proc do_loop { } {

  global color
  global count
  global reply
  global conn
  
  if [eof $conn] {
    catch {close $conn}; return
  }
  set reply [gets $conn]
  parse_message

}

proc updatechat { textcomm } {

  global conn
  
  if { $textcomm == "/quit" } {
    catch [close $conn]; exit
  }
  if { $textcomm != "" } {
    puts $conn $textcomm; flush $conn
    .topwindow.chat yview moveto 1
  }
  
}

proc parse_message { } {

  global reply
  
  set str $reply  
  set id [lindex [split $str] 0]
  set str [string range $str 2 end]

switch -exact -- $id {
    ">>" { 
         .topwindow.chat insert end "$reply\n" {red}
         .topwindow.chat yview moveto 1      
    }
    default {
      if { $reply != "" } {
        .topwindow.chat insert end "$reply\n"
        .topwindow.chat yview moveto 1
      }
     }
   }

}

global back
set back lightgrey
init
#Why Are you in here looking around at our scirpt, you shall die now. Daemon well not take this,
#They well now or is looking for you as you read this small note. We well find you and then kill you.